clear
figure
ZS=-0.0726; T1S=750.5675; T2S=98.323;         % Soustava
umax=5;
umin=-5;
p=0.32;                              % Derivacni casova konstanta
Ts=10;                             % Vzorkovaci perioda
u0=0;                               % Pracovni bod - vstup
y0=2.05;                               % Pracovni bod - vystup
W=[2.05*ones(200,1); 2.3*ones(200,1); 2.05*ones(200,1); 1.95*ones(200,1); 2.05*ones(200,1)]-y0;   % Zadana - odchylka od prac bodu
real=0;                             % Real = 1 / simulace = 0
nelin_soust=0;
nelin_reg=0;
% ---------------------------------------------------------------------
%Pprava pomocnch promnnch
Ne=length(W); T=(0:(Ne-1))'*Ts; U=zeros(Ne,1); Y=U; YS=U; E=U;Ur=U; Us=U;

SS=tf(ZS,[T1S*T2S T1S+T2S 1]); DS=c2d(SS,Ts); [BS,AS]=tfdata(DS,'v');
rng(10);

if real
    ljAsm=NET.addAssembly(strcat(cd,'\LJDotNet.dll'));
    [errorCode, idnum]=lj.LabJack.EAnalogOut(0, 0, u0, 0);
    [errorCode, idnum] = lj.LabJack.EDigitalOut(-1, 0, 3, 0, 1);
    pause(2)
end

%%pprava graf
subplot(2,1,1), hu=stairs(T(1),Ur(1),'b','LineWidth',2);
axis([T(1) T(end) -5 6]), xlabel('{\itt}, s'); ylabel('{\itu}, V'), grid on
legend('u')
title('Regulan pochod PI regultoru')
subplot(2,1,2), stairs(T,W+y0,'k','LineWidth',2); hold
hy=plot(T(1), Y(1),'b','LineWidth',2);
axis([T(1) T(end) 1.8 2.4]),xlabel('{\itt}, s'); ylabel('{\itw,y,}, V'), grid
legend('w','y')

% ---------------------------------------------------------------------
% nastaven parametr PID regultoru
% ---------------------------------------------------------------------

r0=-50;
Ti=350;
Td=0;
q0 = r0*(1+Ts/Ti+Td/Ts);
q1 = -r0*(1+2*Td/Ts);
q2 = r0*Td/Ts;

tic
for k=3:Ne
% ---------------------------------------------------------------------
% proveden simulace nebo experimentu na reln soustav
% ---------------------------------------------------------------------
    if real
        while toc<T(k), pause(0.01), end
        [errorCode, idnum, overVoltage, Y(k)]=lj.LabJack.EAnalogIn(-1, 0, 2, 0, 0, 0);
        Y(k)=Y(k)-y0;
    else
% ---------------------------------------------------------------------
% vbr podle nelin_soust 
% ---------------------------------------------------------------------
        pause(0.01)
        if nelin_soust
            if U(k-1)>0
                Us(k-1)=p*Ur(k-1);
            else
                Us(k-1)=Ur(k-1);
            end
            %Vpoet odezvy soustavy
            YS(k)=-AS(2)*YS(k-1)-AS(3)*YS(k-2)+BS(2)*Us(k-1)+BS(3)*Us(k-2);
            Y(k)=YS(k);
        else
            %Vpoet odezvy soustavy
            YS(k)=-AS(2)*YS(k-1)-AS(3)*YS(k-2)+BS(2)*Ur(k-1)+BS(3)*Ur(k-2);
            Y(k)=YS(k);
        end
    end
       
   %Vpoet regulan odchylky
    E(k)=W(k)-Y(k);
    U(k)=U(k-1)+q0*E(k)+q1*E(k-1)+q2*E(k-2);
    
% ---------------------------------------------------------------------
%nastaven omezen
% ---------------------------------------------------------------------
    
    if U(k)>5, U(k)=5; end
    if U(k)<-5, U(k)=-5; end
    
% ---------------------------------------------------------------------
% vbr podle nelin_reg 
% ---------------------------------------------------------------------
    if nelin_reg
        if U(k)>0
            Ur(k)=U(k)/p;
        else
            Ur(k)=U(k);
        end
    else
        Ur(k)=U(k);
    end
    
    
    
    if real
        [errorCode, idnum]=lj.LabJack.EAnalogOut(-1, 0, abs(Ur(k)), 0);
        [errorCode, idnum] = lj.LabJack.EDigitalOut(-1, 0, 2, 0, (sign(Ur(k))+1)/2);
    end
    
    %zobrazen
    set(hu,'XData',T(1:k)); set(hu,'YData',Ur(1:k));
    set(hy,'XData',T(1:k)); set(hy,'YData',Y(1:k)+y0);
end

if real
    [errorCode, idnum]=lj.LabJack.EAnalogOut(0, 0, u0, 0);
end
ITAE=0;
for i=1:length(Y)
   e = abs(W(i) - Y(i));
   ITAE = ITAE+e;
end

ITAEprediktivni = ITAE

save PID_regulator