clear, %close all
figure
SM=tf(-0.0726,[750.5675*98.323 750.5675+98.323 1]);                   % Model
SS=tf(-0.0726,[750.5675*98.323 750.5675+98.323 1]);                   % Soustava
Ts=10;                             % Vzorkovaci perioda
N2=50;                              % Horizont sledovani zadane (N2>=Nu)
Nu=50;                              % Horizont rizeni
r=10;                                % Penalizace reg. odchylky
q=1;                              % Penalizace zmen akcni
C=[1 -0.8];                         % Filtracni polynom
u0=0;                               % Pracovni bod - vstup
y0=2.05;                               % Pracovni bod - vystup
umax=5;
umin=-5;
kvad=1;
dumin=-1;                           % Minimalni zmna akn
dumax=1;                            % Maximalni zmna akn
W=[2.05*ones(200,1); 2.3*ones(200,1); 2.05*ones(200,1); 1.95*ones(200,1); 2.05*ones(200,1)]-y0;   % Zadana - odchylka od prac bodu
real=0;                             % Real = 1 / simulace = 0
nelin_soust=1;
nelin_reg=1;
p=0.32;
% ---------------------------------------------------------------------
%Pprava pomocnch promnnch
Ne=length(W); T=(0:(Ne-1))'*Ts; U=zeros(Ne,1); Us=U; Ur=U; dU=U; YS=U; Y=YS; Epred=U; ypred=0;

DM=c2d(SM,Ts); [MB,MA]=tfdata(DM,'v'); nM=length(MA)-1;
MAT=conv([1 -1],MA);

DS=c2d(SS,Ts); [SB,SA]=tfdata(DS,'v'); nS=length(SA)-1;
nC=length(C)-1;
[BS,AS]=tfdata(DS,'v');

rng(10);

if real
    ljAsm=NET.addAssembly(strcat(cd,'\LJDotNet.dll'));
    [errorCode, idnum]=lj.LabJack.EAnalogOut(0, 0, u0, 0);
    [errorCode, idnum] = lj.LabJack.EDigitalOut(-1, 0, 3, 0, 1);
    pause(2)
end

%%pprava graf
subplot(2,1,1), hu=stairs(T(1),Ur(1),'b','LineWidth',2); hold
hupred=stairs(T(1),U(1),'r','LineWidth',2);
axis([T(1) T(Ne-N2-1) -5 5]), xlabel('{\itt}, s'); ylabel('{\itu}, V'), grid on
legend('u')
title('Regulan pochod prediktivnho regultoru s uvaovnm omezen')
subplot(2,1,2), stairs(T(1:Ne-N2-1),W(1:Ne-N2-1)+y0,'k','LineWidth',2); hold
hy=plot(T(1), Y(1),'b','LineWidth',2); hypred=plot(T(1), Y(1),'r','LineWidth',2);
axis([T(1) T(Ne-N2-1) 1.8 2.4]), xlabel('{\itt}, s'); ylabel('{\itw,y,}, V'), grid

legend('w','y')

% ---------------------------------------------------------------------
% Pprava matic G,Fp,L,L*Fp
% ---------------------------------------------------------------------
if N2<nM+2, N2p=nM+2; else N2p=N2; end
Ap=[]; Av=zeros(N2p,1); Av(1:nM+2,1)=MAT';
for i=1:N2p
    Ap=[Ap Av];
    Av=[0; Av(1:end-1)];
end
Bp=[]; Bv=zeros(N2p,1); Bv(1:nM,1)=MB(2:end)';
for i=1:N2p
    Bp=[Bp Bv];
    Bv=[0; Bv(1:end-1)];
end
Am=[]; Av=zeros(N2p,1); Av(1:nM+1,1)=-MAT(2:end)';
for i=1:nM+1
    Am=[Am Av];
    Av=[Av(2:end); 0];
end
Bm=[];
if nM==2
    Bv=zeros(N2p,1); Bv(1:nM-1,1)=MB(3:nM+1)'; Bm=[Bm Bv];
end
if nM>2
    for i=2:nM
        Bm=[Bm Bv];
        Bv=[Bv(2:end); 0];
    end
end
Cm=[];
if nC==1
    Cv=zeros(N2p,1); Cv(1:nC,1)=C(2:nC+1)'; Cm=[Cm Cv];
end
if nC>1
    for i=2:nC
        Cm=[Cm Cv];
        Cv=[Cv(2:end); 0];
    end
end
G=inv(Ap)*Bp; G=G(1:N2,1:Nu);
Fp=inv(Ap)*[Am Bm Cm]; Fp=Fp(1:N2,:);
R=r*eye(N2,N2); Q=q*eye(Nu,Nu);
H=G'*R*G+Q;

% ---------------------------------------------------------------------
% vbr quadprog
% ---------------------------------------------------------------------
if kvad
    A=[tril(ones(Nu,Nu)); tril(-ones(Nu,Nu))];
    LB=dumin*ones(Nu,1); UB=dumax*ones(Nu,1);
    opt=optimoptions('quadprog','Algorithm','interior-point-convex');
end

tic
for k=max(nS,nM)+1:Ne-N2
% ---------------------------------------------------------------------
% proveden simulace nebo experimentu na reln soustav
% ---------------------------------------------------------------------
    if real
        while toc<T(k), pause(0.01), end
        [errorCode, idnum, overVoltage, Y(k)]=lj.LabJack.EAnalogIn(-1, 0, 2, 0, 0, 0);
        Y(k)=Y(k)-y0;
    else
% ---------------------------------------------------------------------
% vbr podle nelin_soust 
% ---------------------------------------------------------------------
        pause(0.01)
        if nelin_soust
            if U(k-1)>0
                Us(k-1)=p*Ur(k-1);
            else
                Us(k-1)=Ur(k-1);
            end
            %Vpoet odezvy soustavy
            YS(k)=[-SA(2:end) SB(2:end)]*[flipud(YS(k-nS:k-1)); flipud(Us(k-nS:k-1))];
            Y(k)=YS(k);%+0.001*randn(1,1);
        else
            %Vpoet odezvy soustavy
            YS(k)=[-SA(2:end) SB(2:end)]*[flipud(YS(k-nS:k-1)); flipud(Ur(k-nS:k-1))];
            Y(k)=YS(k);%+0.001*randn(1,1);
        end
    end
    %Vpoet chyby predikce
    Epred(k)=Y(k)-ypred;
    
    %Naplnn Xp
    xp=flipud(Y(k-nM:k));
    if nM>1, xp=[xp; flipud(dU(k-nM+1:k-1))]; end
    if nC>0, xp=[xp; flipud(Epred(k-nC+1:k))]; end
    
    %Vpoet aknho zsahu pomoc regulanho zkonu
    g=G'*R*(Fp*xp-W(k+1:k+N2));
    
    %volba quadprog
    if kvad
        b=[(umax-u0-U(k-1))*ones(Nu,1); -(umin-u0-U(k-1))*ones(Nu,1)]; 
        deltaU=quadprog(H,g,A,b,[],[],LB,UB,[],opt);
    else
        deltaU=-inv(H)*g;
    end
    dU(k)=deltaU(1);
    
    Uopt=cumsum(deltaU)+U(k-1);
    U(k:k+N2-1)=[Uopt; Uopt(end)*ones(N2-Nu,1)];
    
% ---------------------------------------------------------------------
%nastaven omezen
% ---------------------------------------------------------------------
    for i=1:Nu
        if U(k+i-1)>5*p, U(k+i-1)=5*p; end
        if U(k+i-1)<-5, U(k+i-1)=-5; end
    end
     
    % ---------------------------------------------------------------------
    % vbr podle nelin_reg 
    % ---------------------------------------------------------------------
    if nelin_reg
        if U(k)>0
            Ur(k)=U(k)/p;
        else
            Ur(k)=U(k);
        end
    else
        Ur(k)=U(k);
    end

    
    if real
        [errorCode, idnum]=lj.LabJack.EAnalogOut(-1, 0, abs(Ur(k)), 0);
        [errorCode, idnum] = lj.LabJack.EDigitalOut(-1, 0, 2, 0, (sign(Ur(k))+1)/2);
    end
    
    %Vpoet prediktoru
    Y(k+1:k+N2)=G*deltaU+Fp*xp;
    ypred=Y(k+1);
    
    % Zobrazen
    set(hu,'XData',T(1:k)); set(hu,'YData',Ur(1:k)+u0);
    set(hupred,'XData',T(k:k+N2-1)); set(hupred,'YData',U(k:k+N2-1)+u0);
    set(hy,'XData',T(1:k)); set(hy,'YData',Y(1:k)+y0);
    set(hypred,'XData',T(k+1:k+N2)); set(hypred,'YData',Y(k+1:k+N2)+y0);
end

if real
    [errorCode, idnum]=lj.LabJack.EAnalogOut(0, 0, u0, 0);
end

ITAE=0;
for i=1:length(Y)
   e = abs(W(i) - Y(i));
   ITAE = ITAE+e;
end

ITAEprediktivni = ITAE
save prediktivni_regulator_quadprog
